﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Diagnostics;

namespace SampleUnboundDataError
{
    public class SomeDataParent
    {
        private bool _ChildShouldHaveAName;
        public bool ChildShouldHaveAName
        {
            get
            {
                return _ChildShouldHaveAName;
            }
            set
            {
                _ChildShouldHaveAName = value;
                if (_MyChildren != null)
                {
                    foreach (var child in _MyChildren)
                    {
                        child.NotifyPropertyChanged("Name");
                    }
                }
            }
        }

        private ObservableCollection<SomeDataChild> _MyChildren;
        public ObservableCollection<SomeDataChild> MyChildren
        {
            get
            {
                if (_MyChildren == null)
                {
                    _MyChildren = new ObservableCollection<SomeDataChild>();
                    _MyChildren.Add(new SomeDataChild(this));
                    _MyChildren.Add(new SomeDataChild(this));
                }
                return _MyChildren;
            }
        }
    }

    public class SomeDataChild : INotifyPropertyChanged, IDataErrorInfo
    {
        SomeDataParent myParent;
        public SomeDataChild(SomeDataParent parent)
        {
            myParent = parent;
        }

        private string _Name = string.Empty;
        public string Name
        {
            get
            {
                return _Name;
            }
            set
            {
                _Name = value;

            }
        }

        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;
        public void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion

        #region IDataErrorInfo Members

        public string Error
        {
            get { throw new NotImplementedException(); }
        }

        public string this[string columnName]
        {
            get
            {
                string result = null;
                if (columnName == "Name")
                {
                    Debug.WriteLine("IDataErrorInfo Name");
                    if (myParent.ChildShouldHaveAName)
                    {
                        if (string.IsNullOrEmpty(_Name))
                        {
                            Debug.WriteLine("IDataErrorInfo Name returning error.");
                            result = "This child should have a name.";
                        }
                    }
                }

                return result;
            }
        }

        #endregion

    }
}
